package prioritysearch;

import jdsl.core.api.*;
import jdsl.core.ref.*;
import jdsl.geomobj.api.*;
import jdsl.geomobj.ref.*;

public interface ThreeSided2DRangeSearch
{
    /** Initializes a three-sided 2D range search with the given points.
	@param pointIterator an iterator over the points.
    */
    public void initialize(ObjectIterator pointIterator);

    /** Queries the input point set over a range defined by two points.  
	These points lie on either a horizontal or a vertical line.  The
	define two corners of a three sided range search.  The bounded 
	direction is defined by the line on which these points lie.  
	The range is called an open ended or three sided rectangle.
	@param p1 one of the two corners of the three-sided rectangle
	@param p2 the other corner of the three-sided rectangle.
	@return an iterator over the points lying within the open ended 
	rectangle
	@throws RunTimeException if these points do not lie on a vertical
	or a horizontal line
    */
    public ObjectIterator query(Point2D p1, Point2D p2);
}
    
